<template lang='pug'>
mixin prop(name)
  li #[strong.text-info= name+': ']
    block

Example(title='Dialog Example' :maxState='0')
  template(v-slot:description)
    h5 This is a Dialog example
    p
      | This component is used programtically to interact with the user.
    p Click on the #[em animate] to activate the dialog.
    p Click on #[em code] to view and modify its code.
    .d-flex.justify-content-end
      button.mx-1.btn.btn-sm.btn-secondary(@click='showCode = !showCode') code
      button.mx-1.btn.btn-sm.btn-info(@click='showInterface = !showInterface') interface
      button.mx-1.btn.btn-sm.btn-primary(@click='dialog()') animate
    StateComponent(ref='stateCompo' :template='template')
  li(v-show='showInterface' key='x1')
    div #[strong Properties:]
      ul
        +prop("title") the dialog title
    div #[strong Events:]
      ul
        +prop("hidden") emitted with #[code true] whenever the dialog has been hidden from the user,
          |
          | with #[code false] whenever it has been shown to the user
  li(v-show='!$butils.isNil(result) || !$butils.isNil(rejection) || !$butils.isNil(error)' key='x2')
    BaseAnimationGroup
      .alert.alert-success.mb-0(v-if='!$butils.isNil(result)' key='0') #[strong Resolved:] {{ result }}
      .alert.alert-danger.mb-0(v-if='!$butils.isNil(rejection)' key='1') #[strong Rejected:] {{ rejection }}
      .alert.alert-danger.mb-0(v-if='!$butils.isNil(error)' key='2') #[strong Error:] {{ error }}
  li.p-0(v-show='showCode' key='x3')
    CodeMirrorEditor.x-comp-code(ref='compCode' :options="cmOptions" :value='exampleCode')
    span.d-none(ref='exampleCode')
      | // This is the code that will be called when clicking "animate"
      | // result or rejection result will be displayed above
      | try {
      |  this.result = await this.$refs.dialog.request();
      | }
      | catch (err) {
      |  this.rejection = err;
      | }
  li.p-0(v-show='showCode' key='x4')
    PugEditor(ref="pugEditor" @change='setTemplate($event)')
      template(v-pre).
        BaseDialog(ref='dialog' title='This is an example dialog')
          p Some text content ...
          p Do you want to proceed ?
          template(v-slot:footer='d')
            button.btn.btn-danger(@click='d.reject("error")') Error
            button.btn.btn-secondary(@click='d.resolve(false)') Cancel
            button.btn.btn-primary(@click='d.resolve(true)') Ok

</template>
<script>
import { get } from "lodash";
import { CodeMirrorEditor } from "../src";

import PugEditor from "./AppPugEditor";
import StateComponent from "./AppStateComponent";
import Example from "./AppExample.vue";

export default {
  name: "ExampleDialog",
  components: { Example, StateComponent, PugEditor, CodeMirrorEditor },
  data() {
    return {
      showCode: false,
      showInterface: false,
      template: "<div></div>",
      result: null, rejection: null, error: null,
      cmOptions: {
        tabSize: 2, mode: "javascript", lineNumbers: true, line: true,
        readOnly: true
      },
      exampleCode: ""
    };
  },
  watch: {
    showCode() {
      this.$nextTick(() => this.$refs.pugEditor.refresh());
      this.$nextTick(() => this.$refs.compCode.refresh());
    }
  },
  mounted() {
    this.exampleCode = get(this.$refs, [ "exampleCode", "innerText" ], "");
  },
  methods: {
    async dialog() {
      const dialog = get(this.$refs.stateCompo, [ "$refs", "dialog" ]);
      this.result = this.error = this.rejection = null;
      if (!dialog) {
        this.error = "failed to find dialog ref";
      }
      else {
        try {
          this.result = await dialog.request();
        }
        catch (err) {
          this.rejection = err;
        }
      }
    },
    setTemplate(template) {
      this.template = template;
    }
  }
};

</script>
<style>
.x-comp-code .CodeMirror {
  height: auto;
}
/* .x-comp-code .CodeMirror-scroll {
  max-height: 20em;
} */
</style>
